/**
* @author Dirk Nordmann
* @date   24.01.2002
*/
package img2wmf;

import util.*;

public abstract class ImageToImage 
{
  private int width;
  private int height;

  /**
  * Returns the RTF Control-Word for this image.
  * @return String
  */
  public abstract String getRtfControlWorld();

  /**
  * Returns the WMF data for this image.
  */
  public abstract String getWmfData();
  
  /**
  * Returns the RTF for this image.
  * @return String
  */
  public String getRtf() 
  {
    StringBuffer l_sb = new StringBuffer();
   	l_sb.append( "\n{\\pict" );
   	l_sb.append( "\\picw" + (int)(this.getWidth() * Globals.PIX2TWIPS) );
   	l_sb.append( "\\pich" + (int)(this.getHeight() * Globals.PIX2TWIPS) );
   	l_sb.append( "\\picwgoal" + (int)(this.getWidth() * Globals.PIX2TWIPS) );
   	l_sb.append( "\\pichgoal" + (int)(this.getHeight() * Globals.PIX2TWIPS) );
   	l_sb.append( "\\" + this.getRtfControlWorld());
    l_sb.append( "\n" + this.getWmfData());
    l_sb.append( "}" );
    return l_sb.toString();
  }

  /**
  * Sets the height for this image.
  * @param newHeight
  */
  public void setHeight(int newHeight) 
  {
    this.height = newHeight;
  }
  
  /**
  * Returns the height of this image.
  * @return int
  */
  public int getHeight() 
  {
    return this.height;
  }
  
  /**
  * Sets the width for this image.
  * @param newWidth
  */
  public void setWidth(int newWidth) 
  {
    this.width = newWidth;
  }
  
  /**
  * Returns the width of this image.
  * @return int
  */
  public int getWidth() 
  {
    return this.width;
  }

}